module atom_module

use kind_numbers
implicit none
private

integer(kind=int32), parameter, public :: max_line=4 !! maximum number of lines per atom in ".in" file 
integer(kind=int32), public :: ibas
integer(kind=int32), public :: nat,iat,nbas     !! Number & index of atoms
integer(kind=int32), public :: mol_number       !! Number of molecules
integer(kind=int32), dimension(:), allocatable, public :: nb_e_atom  !! Number of atom's electrons 
integer(kind=int32), dimension(:), allocatable, public :: mol_index  !! Molecule index of atom 
integer(kind=int32), dimension(:), allocatable, public :: nb_eval_atom !! Number of atom's valence electrons
integer(kind=int32), dimension(:), allocatable, public :: indx_atoms !! list of valid atoms indices

real(kind=double), public :: nb_e_tot,nb_e_val !! Number of total and valence e-
real(kind=double), public :: lunit             !! Atomic positions scaling read from ".in" file
real(kind=double), public :: r_start           !! Starting radius for basin search 

real(kind=double), dimension(:), allocatable, public :: nb_e_mol       !! Number of electrons in molecule
real(kind=double), dimension(:), allocatable, public :: nb_eval_mol    !! Number of valence electrons in molecule 
real(kind=double), dimension(:), allocatable, public :: mult_factor    !! Atomic multiplicity factor
real(kind=double), dimension(:), allocatable, public :: tot_mol_charge !! molecular total charge
real(kind=double), dimension(:), allocatable, public :: val_mol_charge !! molecular valence charge
real(kind=double), dimension(:), allocatable, public :: mol_volume     !! molecular volume
real(kind=double), dimension(:), allocatable, public :: mol_laplacian  !! molecular laplacian
real(kind=double), dimension(:), allocatable, public :: rstart_atom    !! Starting radii for basin search 
real(kind=double), dimension(:), allocatable, public :: rmin_atom      !! Minimum atomic basin radius
real(kind=double), dimension(:,:), allocatable, public :: atom_prop    !! stock all atoms properties
real(kind=double), dimension(:,:), allocatable, public :: dip_mol      !! molecular dipole
real(kind=double), dimension(:,:), allocatable, public :: ori_mol      !! molecular origin for dipole calculation
real(kind=double), dimension(:,:), allocatable, public :: rat          !! Atomic Positions (cartesian) 
real(kind=double), dimension(:), allocatable, public :: atom_size      !! Size for Dx
real(kind=double), dimension(:,:), allocatable, public :: atom_color   !! Color for Dx
real(kind=double), dimension(:,:), allocatable, public :: integ_prop   !! stock all atoms properties

real(kind=double), dimension(3), public :: quad_eval !! quadrupolar eigen values
real(kind=double), dimension(3), public :: ra        !! Atomic Position (cartesian & absolute origin)
real(kind=double), dimension(3), public :: rag       !! Atomic Position (cartesian & grid origin) 
real(kind=double), dimension(3), public :: rgg       !! Atomic Position (grid) 
real(kind=double), dimension(3,3), public :: quad_mat,quad_evec !! quadrupolar tensor and eigen vectors

character(len=6), dimension(:), allocatable, public :: lat            !! Atoms' Labels 

logical, public :: out_mul           !! flag for multipole file output

end module atom_module
