module file_units_module

use kind_numbers
implicit none
private

integer(kind=int32), parameter, public :: KIU=5      !!! keyboard unit
integer(kind=int32), parameter, public :: SOU=6      !!! screen display unit  ## previously SOU=0
integer(kind=int32), parameter, public :: MIU=10     !!! main input unit (struc, rho, atoms etc.)   
integer(kind=int32), parameter, public :: TOU=11     !!! main temporary output unit (atomic basin file,...)
integer(kind=int32), parameter, public :: BOU=12     !!! basin output file unit ## (plane mode only)
integer(kind=int32), parameter, public :: MOU=13     !!! main output unit, active across all program run
integer(kind=int32), parameter, public :: TIU=14     !!! temporary input unit   
integer(kind=int32), parameter, public :: MUU=15     !!! multipole output file unit
integer(kind=int32), parameter, public :: R1U=17     !!! temporary unit for romberg process output
integer(kind=int32), parameter, public :: R2U=18     !!!    " 
integer(kind=int32), parameter, public :: R3U=19     !!!    "
integer(kind=int32), parameter, public :: R4U=20     !!!    "     
integer(kind=int32), parameter, public :: BLU=21     !!! basin_list unit, used if output inquired for graphics

integer(kind=int32), public :: count_radial,count_phi       

end module file_units_module
