module grid_module !!! grid of PAW-calcul for density

use kind_numbers
implicit none
private

integer(kind=int32), public :: nbx=1,nby=1,nbz=1 !! number of box in each direction for OpendDx
integer(kind=int32), public :: np1,np2,np3 !!! number of grid points

real(kind=double), public :: nmaxdx=1000000 !!! maximum number of printed point for OpenDx
real(kind=double), public :: delv !!! grid mesh volume
real(kind=double), public :: rho_vdv=2.0e-3_double !!! threshold rho value for van der waals surface
real(kind=double), public :: inc1,inc2,inc3 !!! increment in each grid direction
real(kind=double), dimension(3), public :: del1,del2,del3 !!! specify grid in cc
real(kind=double), dimension(3), public :: origin !!! origin of the grid
real(kind=double), dimension(3,2), public :: r_box !!! box boundaries in grid units
real(kind=double), dimension(3,3), public :: g2c,c2g,c2gt !!! transformation matrices grid -> cc

logical, public :: vdv_test,iso_test !!! flag for non periodic grid

character(len=20), public :: extension_tot,extension_val !!! data file extension

end module grid_module
