module results_module

use kind_numbers
implicit none
private

integer(kind=int32), public :: int_time,j_time,h_time,m_time,s_time
integer(kind=int32), dimension(8), public :: datetime,start_time,end_time

real(kind=double), public :: tot_grid_charge   !!! direct sum of total density in the grid
real(kind=double), public :: val_grid_charge   !!! direct sum of valence density in the grid
real(kind=double), public :: tot_interp_charge !!! sum of total density from interpolation on grid
real(kind=double), public :: val_interp_charge !!! sum of valence density from interpolation on grid
real(kind=double), public :: grid_volume       !!!
real(kind=double), public :: rho_tot_min,rho_tot_max   !!! min and max of rho total
real(kind=double), public :: rho_val_min,rho_val_max   !!! min and max of rho valence
real(kind=double), public :: tot_cell_charge   !!! sum of total density over all basins in the cell
real(kind=double), public :: val_cell_charge   !!! sum of valence density over all basins in the cell
real(kind=double), public :: cell_volume       !!! sum over all basins volume in the cell 
real(kind=double), public :: cell_laplacian    !!! integration of Laplacian over all basins in the cell 
real(kind=double), public :: tot_atom_charge   !!! integrated total density over one atomic basin
real(kind=double), public :: val_atom_charge   !!! integrated valence density over one atomic basin
real(kind=double), public :: tot_atom_diff     !!! = ( tot_atom_charge ) - ( total   e- number ) 
real(kind=double), public :: val_atom_diff     !!! = ( val_atom_charge ) - ( valence e- number ) 
real(kind=double), public :: atom_volume       !!! volume of one atomic basin after r,theta,phi integration
real(kind=double), public :: atom_surface      !!! surface of a basin after coarse search
real(kind=double), public :: atom_vol_err      !!! estimation of basin volume error
real(kind=double), public :: tot_vol_err       !!! estimation of basin volume error
real(kind=double), public :: atom_laplacian    !!! r,theta,phi integration of Laplacian over one atomic basin 
real(kind=double), public :: tot_phi_charge    !!! ... integration over r & phi at theta fixed
real(kind=double), public :: val_phi_charge    !!! ... 
real(kind=double), public :: phi_volume        !!! ... 
real(kind=double), public :: phi_laplacian     !!! ... 
real(kind=double), public :: tot_radial_charge !!! ... integration over r at phi & theta fixed 
real(kind=double), public :: val_radial_charge !!! ... 
real(kind=double), public :: radial_laplacian  !!! ... 
real(kind=double), public :: rlim_min,rlim_max !!! Min & Max atomic basin radius

real(kind=double), dimension(6), public :: rad_prop,rad_dprop
real(kind=double), dimension(24), public :: phi_prop,theta_prop,phi_dprop,theta_dprop

logical, public :: boundary_check

end module results_module
