module romberg_module

use kind_numbers
implicit none
private

integer(kind=int32), public :: ntg=60 !! number of theta points, phi points  npg = max(4,int(2*sin(theta)*ntg))
integer(kind=int32), public :: nrg=120 !! number of radial points  drg = rlim(theta,phi) / nrg
integer(kind=int32), public :: nmax=20 !! maximum possible number of iterations
integer(kind=int32), public :: jmax=16 !! effective maximum number of iterations
integer(kind=int32), public :: kmax=5  !! polynomial interpolation order for romberg method
integer(kind=int32), public :: kmin=6  !! minimum iteration number
integer(kind=int32), public :: nloop_theta,nloop_phi_min,nloop_r_min !! romberg procedure statistics
integer(kind=int32), public :: nloop_phi_max,nloop_r_max,nloop_phi
integer(kind=int32), public :: nloop_tot,nloop_equ,nloop_reg,nloop_thph
integer(kind=int32), public :: npg  !! number of angular points for "regular" spherical integration
integer(kind=int32), public :: jmaxp
integer(kind=int32), public :: km1,kint

real(kind=double), public :: dtg,dpg
real(kind=double), public :: eps_r=1.0e-6_double     !! convergence criterion for radial integration ending
real(kind=double), public :: eps_phi=1.0e-4_double   !! idem for phi inegration
real(kind=double), public :: eps_theta=1.0e-4_double !! idem for theta integration

character(len=3), public :: yn_tot,yn_val,yn_lap,yn_vol !! "yes" or "no" as output for criteria
character(len=20), public :: checked_atom !! running atom label used for output purpose
character(len=20), public :: running_mode="auto" !! switch for running mode
character(len=50), public :: dflt_val  !! used on output to specify that "valence" convergence is default one
character(len=256), public :: convergence_test !! coding word for used convergence criteria
character(len=256), public :: conv_string !! character string for convergence criteria output

logical, public :: th_study,ph_study,rh_study !! flags for "manual" working mode
logical, public :: conv_tot,conv_val,conv_vol,conv_lap,conv_rad !! booleans for convergence criteria
logical, public :: out_romberg=.false. !! flags for romberg investigation output files
logical, dimension(24), public :: conv_test  !! convergence flag :: vol,surf,q-tot,q-val,lap,dip,quad

end module romberg_module
